package drills.drill06.exercise1.point1

import org.apache.activemq.ActiveMQConnectionFactory
import javax.jms.QueueConnectionFactory
import javax.jms.Session
import javax.jms.TextMessage

fun main() {
    val url = "tcp://localhost:61616"
    val factory: QueueConnectionFactory = ActiveMQConnectionFactory(url)

    val connection = factory.createQueueConnection()
    connection.start()

    val session = connection.createQueueSession(
        false,
        Session.AUTO_ACKNOWLEDGE
    )

    val queue = session.createQueue("hello")
    val receiver = session.createReceiver(queue)

    val msg = receiver.receive()
    println((msg as TextMessage).text)

    session.close()
    connection.close()
}
